POJ 2288 Islands and Bridges(状压dp)

Language:
Islands and Bridges
Time Limit: 4000MS Memory Limit: 65536K
Total Submissions: 9312 Accepted: 2424

Description

Given a map of islands and bridges that connect these islands, a Hamilton path, as we all know, is a path along the bridges such that it visits each island exactly once. On our map, there is also a positive integer value associated with each island. We call a Hamilton path the best triangular Hamilton path if it maximizes the value described below. 

Suppose there are n islands. The value of a Hamilton path C1C2...Cn is calculated as the sum of three parts. Let Vi be the value for the island Ci. As the first part, we sum over all the Vi values for each island in the path. For the second part, for each edge CiC i+1 in the path, we add the product Vi*V i+1. And for the third part, whenever three consecutive islands CiC i+1C i+2 in the path forms a triangle in the map, i.e. there is a bridge between Ci and C i+2, we add the product Vi*V i+1*V i+2

Most likely but not necessarily, the best triangular Hamilton path you are going to find contains many triangles. It is quite possible that there might be more than one best triangular Hamilton paths; your second task is to find the number of such paths. 

Input

The input file starts with a number q (q<=20) on the first line, which is the number of test cases. Each test case starts with a line with two integers n and m, which are the number of islands and the number of bridges in the map, respectively. The next line contains n positive integers, the i-th number being the Vi value of island i. Each value is no more than 100. The following m lines are in the form x y, which indicates there is a (two way) bridge between island x and island y. Islands are numbered from 1 to n. You may assume there will be no more than 13 islands. 

Output

For each test case, output a line with two numbers, separated by a space. The first number is the maximum value of a best triangular Hamilton path; the second number should be the number of different best triangular Hamilton paths. If the test case does not contain a Hamilton path, the output must be `0 0'. 

Note: A path may be written down in the reversed order. We still think it is the same path.

Sample Input

2
3 3
2 2 2
1 2
2 3
3 1
4 6
1 2 3 4
1 2
1 3
1 4
2 3
2 4
3 4

Sample Output

22 3
69 1

Source




题意: n个点,要求全部走一遍价值最大,价值的计算是 走过点的值相加  加上 每相邻的两个点的价值相乘,如果相邻的3个点组成三角形还要加上这三个值的乘积


思路 :状压dp,我的解法是想初始化状态,还有看看当前的状态可以更新那些状态




// poj 2288

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
#include<queue>
#include<stack>
#include<vector>
#include<set>
#include<map>


#define L(x) (x<<1)
#define R(x) (x<<1|1)
#define MID(x,y) ((x+y)>>1)

#define eps 1e-8
typedef __int64 ll;

#define fre(i,a,b)  for(i = a; i <b; i++)
#define mem(t, v)   memset ((t) , v, sizeof(t))
#define sf(n)       scanf("%d", &n)
#define sff(a,b)    scanf("%d %d", &a, &b)
#define sfff(a,b,c) scanf("%d %d %d", &a, &b, &c)
#define pf          printf
#define bug         pf("Hi\n")

using namespace std;

#define INF 0x3f3f3f3f
#define N 1<<14

ll dp[N][14][14];       // dp[s][i][j] 代表s状态中 i 到达 j 的价值
ll road[N][14][14];     // ........     .....                 路线
ll a[14][14],va[14];
ll n,m;

void solve()
{
	int i,j,k,cur;
	mem(dp,-1);
	mem(road,0);

	fre(i,1,n+1)
	 fre(j,1,n+1)
	  if(a[i][j]&&i!=j)
	  {
	  	 cur=1<<(i-1);
	  	 cur|=1<<(j-1);
	  	 dp[cur][i][j]=va[i]+va[j]+va[i]*va[j];  // i->j  初始化
	  	 road[cur][i][j]=1;
	  }

    ll len=1<<n;
    ll to;

    fre(cur,0,len)
     fre(i,1,n+1)
      {
      	 if(!(cur&(1<<(i-1)))) continue;   //没有经过 i

      	 fre(j,1,n+1)
		{
      	     if(!(cur&(1<<(j-1)))) continue;    //没有经过j

      	     if(!a[i][j]||i==j) continue;      //i j 没有路

      	     if(dp[cur][i][j]==-1) continue;     
      	              //此状态没有被到达过(因为用这个状态更新别的状态)

      	     fre(to,1,n+1)
      	     {
      	     	 if(a[j][to]==0) continue;   //枚举下一个到的点

      	     	 if(i==to||j==to) continue;

                 if(cur&(1<<(to-1))) continue;   //该状态没有to点

      	     	 int temp=dp[cur][i][j]+va[to]+va[j]*va[to];

      	     	 if(a[i][to]) temp+=va[i]*va[j]*va[to];   //形成三角形  

      	     	 int next=cur|(1<<(to-1));

                // if(next==len-1) bug;

      	     	 if(dp[next][j][to]<temp)
				 {
				 	 dp[next][j][to]=temp;
				 	 road[next][j][to]=road[cur][i][j];
				 }
                 else
					if(dp[next][j][to]==temp)
				   {
				 	  road[next][j][to]+=road[cur][i][j];
				   }
      	     }

		}
	}

	ll ans=0,ma=-1;
	len--;

	fre(i,1,n+1)
	 fre(j,1,n+1)
	 {
	 	if(i==j||a[i][j]==0) continue;
	 	if(dp[len][i][j]==-1) continue;

	 	if(dp[len][i][j]>ma)
		{
			ans=road[len][i][j];
			ma=dp[len][i][j];
		}
        else
			if(ma==dp[len][i][j])
			  ans+=road[len][i][j];
	 }


	if(ma==-1)
		printf("0 0\n");
	else
		printf("%I64d %I64d\n",ma,ans/2);


}

int main()
{
	int i,j,t;
	sf(t);

	while(t--)
	{

		scanf("%I64d%I64d",&n,&m);

		fre(i,1,n+1)
		  {
		  	scanf("%I64d",&va[i]);
		  }
		mem(a,0);
		ll s,e;

		while(m--)
		{
			scanf("%I64d%I64d",&s,&e);
			a[s][e]=a[e][s]=1;
		}


		  if(n==1)
		 {
			pf("%I64d 1\n",va[1]);
			continue;
		 }

	  solve();

	}
    return 0;

}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目描述 给出一个$n\times m$的矩阵,每个位置上有一个非负整数,代表这个位置的海拔高度。一开始时,有一个人站在其中一个位置上。这个人可以向上、下、左、右四个方向移动,但是只能移动到海拔高度比当前位置低或者相等的位置上。一次移动只能移动一个单位长度。定义一个位置为“山顶”,当且仅当从这个位置开始移动,可以一直走到海拔高度比它低的位置上。请问,这个矩阵中最多有多少个“山顶”? 输入格式 第一行两个整数,分别表示$n$和$m$。 接下来$n$行,每行$m$个整数,表示整个矩阵。 输出格式 输出一个整数,表示最多有多少个“山顶”。 样例输入 4 4 3 2 1 4 2 3 4 3 5 6 7 8 4 5 6 7 样例输出 5 算法1 (递归dp) $O(nm)$ 对于这道题,我们可以使用递归DP来解决,用$f(i,j)$表示以$(i,j)$为起点的路径最大长度,那么最后的答案就是所有$f(i,j)$中的最大值。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码 算法2 (动态规划) $O(nm)$ 动态规划的思路与递归DP类似,只不过转移方程和实现方式有所不同。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值